<?php
session_start();
extract($_POST);
extract($_GET);

require "connection_manager.php";
require_once('classes/tc_calendar.php');
$conn = new connection_manager();
$dbConn = $conn->connection;
if(!isset($_SESSION["username"])) {                       // This variable is set to zero for the first page
    header("Location: .index.php");
}

//$date_day,$date_month,$date_year
//SELECT * FROM defect WHERE DtCreate > now() - interval 30 day
$chart_title = "";
$sql_filter = "";

if($ProjId != "") {
    $sql_filter .= " AND ProjId = '$ProjId'";
}

if($date_year != "" && $date_month != "" && $date_day != ""){
    $date_str = "$date_year-$date_month-$date_day";
}
else{
    date_default_timezone_set('Asia/Kuala_Lumpur'); 
    $date_str = date("Y-m-d");
}

//prepare the query
$date_selected = new DateTime($date_str);

$date_selected->modify('-14 day');
$days_14 = $date_selected->format('Y-m-d');

//minus another 16 days 
$date_selected->modify('-16 day');
$days_month = $date_selected->format('Y-m-d');

$sql = "SELECT COUNT(*) FROM defect WHERE DelFlag = '0' AND WFSTATUS NOT IN ('CLOSED','PENDING') AND DtCreate BETWEEN '$days_14' AND '$days_month'" . $sql_filter;
$count_14 = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];

$sql = "SELECT COUNT(*) FROM defect WHERE  DelFlag = '0' AND WFSTATUS NOT IN ('CLOSED','PENDING') AND DtCreate < '$days_month'" . $sql_filter;
$count_month = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];

$sql = "SELECT COUNT(*),WFStatus FROM defect WHERE DelFlag = '0' AND WFStatus IN ('PENDING','CLOSED')";
if($ProjId != "") $sql .= " AND ProjId = '$ProjId'";
$sql .= "GROUP BY WFStatus";
$result = mysql_query($sql);

//put the data into an array then pass to draw chart function below
$names = array();
$counts = array();

while($row = mysql_fetch_assoc($result)){
    array_push($names, $row["WFStatus"]);
    array_push($counts, (int)$row["COUNT(*)"]);
}

array_push($names, "> 14 DAYS");
array_push($counts, 0);

array_push($names, "> 1 MONTH");
array_push($counts, (int)$count_month);

$dataPoints = array();

//put the data into an array then pass to draw chart function below
for($i = 0; $i < sizeof($names); $i++){
    //calculate the percentage if needed
    //$percentage = (float)($counts[$i] / $total) * 100;
    $data = "['$names[$i]',$counts[$i]]";
    array_push($dataPoints, $data);
}



/*$dataPoints = array( 
	array("label"=>"Industrial", "y"=>51.7),
	array("label"=>"Transportation", "y"=>26.6),
	array("label"=>"Residential", "y"=>13.9),
	array("label"=>"Commercial", "y"=>7.8)
)*/
 
?>
<?php include("header.php");?>
<?php include("header-defect.php");?>
<!DOCTYPE HTML>
<html>

<head>
</head>

<body>
    <div id="content">
        <div id="main">
            <div id="main-title">Dashboard</div>

            <form method="get" action="welcome-dashboard.php">
                <table style="margin-left: 180px; margin-bottom:80px; float:left; position:absolute; z-index : 10"  width="40%" cellpadding="6" bgcolor="#FFFFFF">
                    
                    <tr valign="middle" class="tablerowdata" bgcolor="#FAFAFA">
                        <td>
                            <b>Project : <b>
                            <select name="ProjId" id="ProjId" onchange="update_chart()">
                                    <option value="" selected> All Projects </option>
                                    <?
                                    $sql = "SELECT * FROM project ORDER BY ProjName";
                                    $result = mysql_query($sql);
                                    while($row = mysql_fetch_assoc($result)){
                                    ?>
                                        <option <?if ($row["ProjId"] == $ProjId) echo "selected" ?> value='<?echo $row[ProjId]?>'> <?echo $row[ProjName]?></option>";
                                    <?
                                    }
                                    ?>
                            </select>
                        </td>
                        <td height="21" width="100" align="left" font color="#333333"><b>Date From:<b></td>
                        <td height="21" align="left">
                            <?php
                                //get current date for defult
                                date_default_timezone_set('Asia/Kuala_Lumpur'); 

                                $myCalendar = new tc_calendar("date", true);
                                $myCalendar->setIcon("images/icons/calendar.png");
                                if($date_year != "" && $date_month != "" && $date_day != "") $myCalendar->setDate($date_day, $date_month, $date_year);
                                else  $myCalendar->setDate(date("d"), date("m"), date("Y"));
                                $myCalendar->setPath("./");
                                $myCalendar->setYearInterval(2015, 2050);
                                $myCalendar->writeScript();
                            ?>
                        </td>

                        <td align="center">
                            <input type="submit" name="generate_chart" id="generate_chart" value="Search">
                        </td>
                    </tr>
                </table>
            </form>
            <div id="chartContainer" style="position:absolute; left: 10%;"></div>

        </div>
    </div>
</body>

<script>
window.onload = function() {
    google.charts.load("current", {packages:["corechart"]});
    google.charts.setOnLoadCallback(drawChart);
    function drawChart() {
        var data = google.visualization.arrayToDataTable([
            ['Status', 'Number Of Cases'],
            <?foreach($dataPoints as $data) echo $data . ","?>
        ]);

        var options = {
            pieSliceText: 'label',
            title: '<?echo $chart_title?>',
            width: 900, 
            height: 500,
        };

        var chart = new google.visualization.PieChart(document.getElementById('chartContainer'));
        google.visualization.events.addListener(chart, 'select', (e)=>{
            WFStatus = data.getValue(chart.getSelection()[0].row, 0)
            window.open('welcome-dashboard-popup.php?ProjId=<?echo $ProjId?>&status='+ WFStatus + '&days14=<?echo $days_14?>&daysmonth=<?echo $days_month?>', '', 'width=1400,height=500,scrollbars=no');
            window.location.reload();
        }); 

        chart.draw(data, options);
    }
}

update_chart = () =>{
    //do something
}
</script>

</html>