<?php
session_start();
extract($_POST);
extract($_GET);

require "connection_manager.php";
require_once('classes/tc_calendar.php');
$conn = new connection_manager();
$dbConn = $conn->connection;
if(!isset($_SESSION["username"])) {                       // This variable is set to zero for the first page
    header("Location: .index.php");
}

//$date_day,$date_month,$date_year
//SELECT * FROM defect WHERE DtCreate > now() - interval 30 day

date_default_timezone_set('Asia/Kuala_Lumpur'); 

if($date_year != "" && $date_month != "" && $date_day != ""){
    $date_str = "$date_year-$date_month-$date_day";
}
else{
    $date_str = date("Y-m-d");
}

//prepare the date for the query
$date_selected = new DateTime($date_str);

$date_selected->modify('-14 day');
$days_14 = $date_selected->format('Y-m-d'); 

//minus another 16 days 
$date_selected->modify('-16 day');
$days_month = $date_selected->format('Y-m-d');

function get_dataPoints($ProjId){
    $sql_filter .= " AND ProjId = '$ProjId'";

    $sql_filter .= " AND Defect_TypeCode in ('PRE TRADE','PROGRESS TRADE','POST TRADE','PRE DELIVERY INSPECTION','SAFETY')";
    global $days_14,$days_month;
    
    $sql = "SELECT COUNT(*) FROM defect WHERE DelFlag = '0' AND WFSTATUS <> 'CLOSED' AND DATE_FORMAT(DtCreate, '%Y-%m-%d') BETWEEN '$days_month' AND '$days_14'" . $sql_filter;
    $count_14 = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];
    
    $sql = "SELECT COUNT(*) FROM defect WHERE  DelFlag = '0' AND WFSTATUS <> 'CLOSED' AND DATE_FORMAT(DtCreate, '%Y-%m-%d') < '$days_month'" . $sql_filter;
    $count_month = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];
    
    $sql = "SELECT COUNT(*) FROM defect WHERE  DelFlag = '0' AND WFSTATUS = 'PENDING'" . $sql_filter;
    $count_pending = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];
    
    $sql = "SELECT COUNT(*) FROM defect WHERE  DelFlag = '0' AND WFSTATUS <> 'CLOSED' AND  AND WFSTATUS = 'PendingForApproval'" . $sql_filter;
    $count_pendingforapproval = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];
    
    $sql = "SELECT COUNT(*) FROM defect WHERE  DelFlag = '0' AND WFSTATUS = 'CLOSED' " . $sql_filter;
    $count_closed = mysql_fetch_assoc(mysql_query($sql))["COUNT(*)"];
    //$sql = "SELECT COUNT(*),WFStatus FROM defect WHERE DelFlag = '0' AND WFStatus IN ('PENDING','CLOSED')";
    //if($ProjId != "") $sql .= " AND ProjId = '$ProjId'";
    //$sql .= "GROUP BY WFStatus";
    //$result = mysql_query($sql);
    
    //put the data into an array then pass to draw chart function below
    $names = array();
    $counts = array();
    
    //while($row = mysql_fetch_assoc($result)){
    //    array_push($names, $row["WFStatus"]);
    //    array_push($counts, (int)$row["COUNT(*)"]);
    //}
    
    array_push($names, "PENDING");
    array_push($counts, (int)$count_pending);
    
    array_push($names, "PENDING FOR APPROVAL");
    array_push($counts, (int)$count_pendingforapproval);
    
    array_push($names, "CLOSED");
    array_push($counts, (int)$count_closed);
    
    array_push($names, "> 14 DAYS");
    array_push($counts, (int)$count_14);
    
    array_push($names, "> 1 MONTH");
    array_push($counts, (int)$count_month);
    
    $dataPoints = array();
    
    //put the data into an array then pass to draw chart function below
    for($i = 0; $i < sizeof($names); $i++){
        $data = "['$names[$i]',$counts[$i]]";
        array_push($dataPoints, $data);
    }

    return $dataPoints;
}
 
?>
<?php include("header.php");?>
<?php include("header-defect.php");?>
<!DOCTYPE HTML>
<html>

<head>
</head>

<body>
    <div id="content">
        <div id="main">
            <div id="main-title">Dashboard</div>

            <form method="get" action="welcome-dashboard.php">
                <table style="margin-left: 180px; margin-bottom:80px; float:left; position:absolute; z-index : 10"  width="60%" cellpadding="6" bgcolor="#FFFFFF">
                    
                    <tr valign="middle" class="tablerowdata" bgcolor="#FAFAFA">
                        <td>
                            <b>Project Name : <b>
                        </td>
                        <td>
                            <select name="ProjId" id="ProjId" onchange="update_chart()">
                                    <option value="" selected> All Projects </option>
                                    <?
                                    if($_SESSION[accesslevel]=="SA"){$sql="SELECT * FROM project WHERE projCode!='' and projCode!='TRIAL' AND DELFLAG = 0  ORDER BY ProjName";}
                                    else{if($_SESSION[origin]=="SUBCON"){$sql="SELECT * FROM project WHERE projCode!='TRIAL' and ProjId in (select ProjId from project_subco where SubcoId=(select CoId from company where coname =(select location from systemuser where username='$_SESSION[username]'))) AND DELFLAG = 0  ORDER BY ProjName";}
                                    else {$sql = "SELECT * FROM project WHERE proCode!='TRIAL' and projCode IN (SELECT ProjId FROM project_member WHERE EmpId = '$_SESSION[username]') AND OriginId='$_SESSION[origin] AND DELFLAG = 0  ORDER BY ProjName";}
                                    }
                                    echo $sql;
                                    $res=mysql_query($sql);
                                    while($row=mysql_fetch_array($res))
                                    {
                                    ?>
                                    <option value="<?= $row[ProjId]?>"><?= $row[ProjCode]?></option>
                                    <?
                                    }
                                    ?>
                            </select>
                            <? //echo project_filter();?>
                        </td>
                        <td height="21" width="100" align="left" font color="#333333"><b>Date :<b></td>
                        <td height="21" align="left"><input type="date" id="date" name="date" value="<?=date("Y-m-d");?>"/>
                            <?/*
                                //get current date for defult
                                date_default_timezone_set('Asia/Kuala_Lumpur'); 

                                $myCalendar = new tc_calendar("date", true);
                                $myCalendar->setIcon("images/icons/calendar.png");
                                if($date_year != "" && $date_month != "" && $date_day != "") $myCalendar->setDate($date_day, $date_month, $date_year);
                                else  $myCalendar->setDate(date("d"), date("m"), date("Y"));
                                $myCalendar->setPath("./");
                                $myCalendar->setYearInterval(2015, 2050);
                                $myCalendar->writeScript();*/
                            ?>
                        </td>

                        <td align="center">
                            <input type="submit" name="generate_chart" id="generate_chart" value="Search">
                        </td>
                    </tr>
                </table>
            </form>
            <div id="chartContainer" style="position:absolute; left: 10%; top:20%"></div>

        </div>
    </div>
</body>

<script >

window.onload = function() {
    google.charts.load("current", {packages:["corechart"]});
    google.charts.setOnLoadCallback(()=>{
    <?
    //if the project field is empty, diaplay all charts
    if($ProjId == ""){
        if($_SESSION[accesslevel]=="SA"){$sql="SELECT * FROM project WHERE projCode!='TRIAL' AND projCode!='' AND DELFLAG = 0  ORDER BY ProjName";}
        else{if($_SESSION[origin]=="SUBCON"){$sql="SELECT * FROM project WHERE projCode!='TRIAL' AND ProjId in (select ProjId from project_subco where SubcoId=(select CoId from company where coname =(select location from systemuser where username='$_SESSION[username]'))) AND DELFLAG = 0  ORDER BY ProjName";}
                                    
        else {$sql = "SELECT * FROM project WHERE projCode!='TRIAL' AND projCode IN (SELECT ProjId FROM project_member WHERE EmpId = '$_SESSION[username]') AND DELFLAG = 0  ORDER BY ProjName";}
        }
        $result = mysql_query($sql);
        while($proj = mysql_fetch_assoc($result)){
            $dataPoints = get_dataPoints($proj["ProjId"]);
    ?>
        var data = google.visualization.arrayToDataTable([
            ['Status', 'Number Of Cases'],
            <?foreach($dataPoints as $data) echo $data . ","?>
        ]);
        drawChart(data,"Defect Status Of <?echo $proj["ProjName"]?>",400,300,'<?echo $proj["ProjId"]?>');

    <?
        }
    }
    else {
        //if the project is specified, display one chart instead
        $dataPoints = get_dataPoints($ProjId);
        $sql = "SELECT ProjName FROM project WHERE ProjId = '$ProjId' AND " . project_filter();
        $ProjName = mysql_fetch_assoc(mysql_query($sql))["ProjName"]
    ?>
        var data = google.visualization.arrayToDataTable([
            ['Status', 'Number Of Cases'],
            <?foreach($dataPoints as $data) echo $data . ","?>
        ]);
        console.log("<?foreach($dataPoints as $data) echo $data . ","?>")
        drawChart(data,"Defect Status Of <?echo $ProjName?>",900,500,'<?echo $ProjId?>');
    <?
    }
    ?>
     });
}

function drawChart(data,title,width,height,ProjId) {
    
    var options = {
        pieSliceText: 'label',
        title: title,
        width: width, 
        height: height,
        sliceVisibilityThreshold: 0.0001,
        colors: ['#0000FF','#FFFF00', '#00FF00', '#FFAA00', '#FF0000']
        //is3D:true
    };

    chart_sub = document.createElement("div");
    chart_sub.style.float = "left";
    chart_sub.setAttribute("id", "chart1");
    document.getElementById('chartContainer').appendChild(chart_sub);
    var chart = new google.visualization.PieChart(chart_sub);
        google.visualization.events.addListener(chart, 'select', (e)=>{
        WFStatus = data.getValue(chart.getSelection()[0].row, 0)
        window.open('welcome-dashboard-popup.php?ProjId='+ ProjId +'&status='+ WFStatus + '&days14=<?echo $days_14?>&daysmonth=<?echo $days_month?>', '', 'width=1400,height=500,scrollbars=no');
        //window.location.reload();
    }); 
    chart.draw(data, options);
}
</script>

</html>